Index: /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 253)
@@ -1,35 +1,34 @@
-      subroutine aeroptproperties(ngrid,nlayer,reffrad,nueffrad, &
-                                 QVISsQREF3d,omegaVIS3d,gVIS3d, &
-                                 QIRsQREF3d,omegaIR3d,gIR3d,    &
-                                 QREFvis3d,QREFir3d)
+      SUBROUTINE aeroptproperties(ngrid,nlayer,reffrad,nueffrad,   &
+                                  QVISsQREF3d,omegaVIS3d,gVIS3d,   &
+                                  QIRsQREF3d,omegaIR3d,gIR3d,      &
+                                  QREFvis3d,QREFir3d)!,		   &
+!                                  omegaREFvis3d,omegaREFir3d)
 
       use radinc_h,    only: L_NSPECTI,L_NSPECTV,naerkind,nsizemax
       use radcommon_h, only: QVISsQREF,omegavis,gvis,QIRsQREF,omegair,gir
-      use radcommon_h, only: radiustab,nsize,qrefvis,qrefir
+      use radcommon_h, only: qrefvis,qrefir,omegarefvis,omegarefir
+      use radcommon_h, only: radiustab,nsize
 
       implicit none
 
-!==================================================================
-!     
-!     Purpose
-!     -------
-!     Compute the scattering parameters in each grid
-!     box, depending on aerosol grain sizes.
+!     =============================================================
+!     Aerosol Optical Properties
 !
-!     Notes
-!     -----
-!     Don't forget to set the value of varyingnueff below; If
-!     the effective variance of the distribution for the given
-!     aerosol is considered homogeneous in the atmosphere, please
-!     set varyingnueff(iaer) to .false. Resulting computational
-!     time will be much better.
-!
-!     Authors
-!     ------- 
-!     J.-B. Madeleine, F. Montmessin
+!     Description:
+!       Compute the scattering parameters in each grid
+!       box, depending on aerosol grain sizes. Log-normal size
+!       distribution and Gauss-Legendre integration are used.
+
+!     Parameters:
+!       Don't forget to set the value of varyingnueff below; If
+!       the effective variance of the distribution for the given
+!       aerosol is considered homogeneous in the atmosphere, please
+!       set varyingnueff(iaer) to .false. Resulting computational
+!       time will be much better.
+
+!     Authors: J.-B. Madeleine, F. Forget, F. Montmessin
 !     Slightly modified and converted to F90 by R. Wordsworth (2009)
 !     Varying nueff section removed by R. Wordsworth for simplicity
-!     
-!==================================================================
+!     ==============================================================
 
 #include "dimensions.h"
@@ -40,38 +39,52 @@
 !     ---------------
 
+
+
 !     =============================================================
       LOGICAL, PARAMETER :: varyingnueff(naerkind) = .false.
 !     =============================================================
 
-!     Radius axis used for integration 
-      DOUBLE PRECISION :: radiusint(nsizemax+1)
-!     Min. and max radii of the interpolation grid (in METERS)
-      REAL, PARAMETER :: refftabmin = 2e-8
+!     Min. and max radius of the interpolation grid (in METERS)
+      REAL, PARAMETER :: refftabmin = 2e-8 !2e-8
 !      REAL, PARAMETER :: refftabmax = 35e-6
-      REAL, PARAMETER :: refftabmax = 1e-3 ! CHANGED BY RDW
+      REAL, PARAMETER :: refftabmax = 1e-3
 !     Log of the min and max variance of the interpolation grid
       REAL, PARAMETER :: nuefftabmin = -4.6
       REAL, PARAMETER :: nuefftabmax = 0.
-!     Number of effective radii of the interpolation grid
+!     Number of effective radius of the interpolation grid
       INTEGER, PARAMETER :: refftabsize = 200
 !     Number of effective variances of the interpolation grid
 !      INTEGER, PARAMETER :: nuefftabsize = 100
-      INTEGER, PARAMETER :: nuefftabsize = 1  ! CHANGED BY RDW
+      INTEGER, PARAMETER :: nuefftabsize = 1
 !     Interpolation grid indices (reff,nueff)
       INTEGER :: grid_i,grid_j
-!     Volume ratio of the look-up table (different in VIS and IR)
-      DOUBLE PRECISION :: vrat
-!     r_g and sigma_g for the log-normal distribution
-!       as defined by [hansen_1974]
-      REAL :: r_g,sigma_g
-!     Error function used for integration
-      DOUBLE PRECISION :: derf
-!     Density function f(x)dx of the log-normal distribution
-      REAL :: dfi
-      DOUBLE PRECISION :: dfi_tmp(nsizemax+1)
 !     Intermediate variable
       REAL :: var_tmp,var3d_tmp(ngridmx,nlayermx)
 !     Bilinear interpolation factors
       REAL :: kx,ky,k1,k2,k3,k4
+!     Size distribution parameters
+      REAL :: sizedistk1,sizedistk2
+!     Pi!
+      REAL,SAVE :: pi
+!     Variables used by the Gauss-Legendre integration:
+      INTEGER radius_id,gausind
+      REAL kint
+      REAL drad
+      INTEGER, PARAMETER :: ngau = 10
+      REAL weightgaus(ngau),radgaus(ngau)
+      SAVE weightgaus,radgaus
+!      DATA weightgaus/.2955242247,.2692667193,.2190863625,.1494513491,.0666713443/
+!      DATA radgaus/.1488743389,.4333953941,.6794095682,.8650633666,.9739065285/
+      DATA    radgaus/0.07652652113350,0.22778585114165, &
+                      0.37370608871528,0.51086700195146, &
+                      0.63605368072468,0.74633190646476, &
+                      0.83911697181213,0.91223442826796, &
+                      0.96397192726078,0.99312859919241/
+
+      DATA weightgaus/0.15275338723120,0.14917298659407, &
+                      0.14209610937519,0.13168863843930, &
+                      0.11819453196154,0.10193011980823, &
+                      0.08327674160932,0.06267204829828, &
+                      0.04060142982019,0.01761400714091/
 !     Indices
       INTEGER :: i,j,k,l,m,iaer,idomain
@@ -82,25 +95,64 @@
 
 !     Radius axis of the interpolation grid
-      DOUBLE PRECISION,SAVE :: refftab(refftabsize)
+      REAL,SAVE :: refftab(refftabsize)
 !     Variance axis of the interpolation grid
-      DOUBLE PRECISION,SAVE :: nuefftab(nuefftabsize)
+      REAL,SAVE :: nuefftab(nuefftabsize)
 !     Volume ratio of the grid
-      DOUBLE PRECISION,SAVE :: logvratgrid,vratgrid
+      REAL,SAVE :: logvratgrid,vratgrid
 !     Grid used to remember which calculation is done
-      LOGICAL,SAVE :: checkgrid(refftabsize,nuefftabsize,naerkind,2) &
-                     = .false.
+      LOGICAL,SAVE :: checkgrid(refftabsize,nuefftabsize,naerkind,2) = .false.
 !     Optical properties of the grid (VISIBLE)
-      REAL,SAVE :: epVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
+      REAL,SAVE :: qsqrefVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
+      REAL,SAVE :: qextVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
+      REAL,SAVE :: qscatVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
       REAL,SAVE :: omegVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
       REAL,SAVE :: gVISgrid(refftabsize,nuefftabsize,L_NSPECTV,naerkind)
 !     Optical properties of the grid (INFRARED)
-      REAL,SAVE :: epIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
+      REAL,SAVE :: qsqrefIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
+      REAL,SAVE :: qextIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
+      REAL,SAVE :: qscatIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
       REAL,SAVE :: omegIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
       REAL,SAVE :: gIRgrid(refftabsize,nuefftabsize,L_NSPECTI,naerkind)
 !     Optical properties of the grid (REFERENCE WAVELENGTHS)
-      REAL,SAVE :: eprefVISgrid(refftabsize,nuefftabsize,naerkind)
-      REAL,SAVE :: eprefIRgrid(refftabsize,nuefftabsize,naerkind)
+      REAL,SAVE :: qrefVISgrid(refftabsize,nuefftabsize,naerkind)
+      REAL,SAVE :: qscatrefVISgrid(refftabsize,nuefftabsize,naerkind)
+      REAL,SAVE :: qrefIRgrid(refftabsize,nuefftabsize,naerkind)
+      REAL,SAVE :: qscatrefIRgrid(refftabsize,nuefftabsize,naerkind)
+      REAL,SAVE :: omegrefVISgrid(refftabsize,nuefftabsize,naerkind)
+      REAL,SAVE :: omegrefIRgrid(refftabsize,nuefftabsize,naerkind)
 !     Firstcall
       LOGICAL,SAVE :: firstcall = .true.
+!     Variables used by the Gauss-Legendre integration:
+      REAL,SAVE :: normd(refftabsize,nuefftabsize,naerkind,2)
+      REAL,SAVE :: dista(refftabsize,nuefftabsize,naerkind,2,ngau)
+      REAL,SAVE :: distb(refftabsize,nuefftabsize,naerkind,2,ngau)
+
+      REAL,SAVE :: radGAUSa(ngau,naerkind,2)
+      REAL,SAVE :: radGAUSb(ngau,naerkind,2)
+
+      REAL,SAVE :: qsqrefVISa(L_NSPECTV,ngau,naerkind)
+      REAL,SAVE :: qrefVISa(ngau,naerkind)
+      REAL,SAVE :: qsqrefVISb(L_NSPECTV,ngau,naerkind)
+      REAL,SAVE :: qrefVISb(ngau,naerkind)
+      REAL,SAVE :: omegVISa(L_NSPECTV,ngau,naerkind)
+      REAL,SAVE :: omegrefVISa(ngau,naerkind)
+      REAL,SAVE :: omegVISb(L_NSPECTV,ngau,naerkind)
+      REAL,SAVE :: omegrefVISb(ngau,naerkind)
+      REAL,SAVE :: gVISa(L_NSPECTV,ngau,naerkind)
+      REAL,SAVE :: gVISb(L_NSPECTV,ngau,naerkind)
+
+      REAL,SAVE :: qsqrefIRa(L_NSPECTI,ngau,naerkind)
+      REAL,SAVE :: qrefIRa(ngau,naerkind)
+      REAL,SAVE :: qsqrefIRb(L_NSPECTI,ngau,naerkind)
+      REAL,SAVE :: qrefIRb(ngau,naerkind)
+      REAL,SAVE :: omegIRa(L_NSPECTI,ngau,naerkind)
+      REAL,SAVE :: omegrefIRa(ngau,naerkind)
+      REAL,SAVE :: omegIRb(L_NSPECTI,ngau,naerkind)
+      REAL,SAVE :: omegrefIRb(ngau,naerkind)
+      REAL,SAVE :: gIRa(L_NSPECTI,ngau,naerkind)
+      REAL,SAVE :: gIRb(L_NSPECTI,ngau,naerkind)
+
+      REAL :: radiusm
+      REAL :: radiusr
 
 !     Inputs
@@ -127,8 +179,9 @@
       REAL :: QREFir3d(ngridmx,nlayermx,naerkind)
 
+      REAL :: omegaREFvis3d(ngridmx,nlayermx,naerkind)
+      REAL :: omegaREFir3d(ngridmx,nlayermx,naerkind)
+
       DO iaer = 1, naerkind ! Loop on aerosol kind
-
         IF ( (nsize(iaer,1).EQ.1).AND.(nsize(iaer,2).EQ.1) ) THEN
-
 !==================================================================
 !       If there is one single particle size, optical
@@ -148,6 +201,9 @@
               QREFvis3d(ig,lg,iaer)=QREFvis(iaer,1)
               QREFir3d(ig,lg,iaer)=QREFir(iaer,1)
+              omegaREFvis3d(ig,lg,iaer)=omegaREFvis(iaer,1)
+              omegaREFir3d(ig,lg,iaer)=omegaREFir(iaer,1)
             ENDDO
           ENDDO
+
 
           if (firstcall) then
@@ -162,10 +218,13 @@
 !     --------------------------------------------------
       IF (firstcall) THEN
-!       1.1 Effective radius
+
+!       1.1 Pi!
+        pi = 2. * asin(1.e0)
+
+!       1.2 Effective radius
         refftab(1)    = refftabmin
         refftab(refftabsize) = refftabmax
 
-        logvratgrid = log(refftabmax/refftabmin) / &
-                     float(refftabsize-1)*3.
+        logvratgrid = log(refftabmax/refftabmin) / float(refftabsize-1)*3.
         vratgrid = exp(logvratgrid)
 
@@ -174,31 +233,149 @@
         enddo
 
-!       1.2 Effective variance
-        do i = 0, nuefftabsize-1
-          nuefftab(i+1) = exp( nuefftabmin + &
-                  i*(nuefftabmax-nuefftabmin)/(nuefftabsize-1) )
-        enddo
+!       1.3 Effective variance
+        if(nuefftabsize.eq.1)then ! addded by RDW
+           print*,'Warning: no variance range in aeroptproperties'
+           nuefftab(1)=0.2
+        else
+           do i = 0, nuefftabsize-1
+              nuefftab(i+1) = exp( nuefftabmin + i*(nuefftabmax-nuefftabmin)/(nuefftabsize-1) )
+           enddo
+        endif
+
         firstcall = .false.
       ENDIF
 
-
+!       1.4 Radius middle point and range for Gauss integration
+        radiusm=0.5*(radiustab(iaer,idomain,nsize(iaer,idomain)) + radiustab(iaer,idomain,1))
+        radiusr=0.5*(radiustab(iaer,idomain,nsize(iaer,idomain)) - radiustab(iaer,idomain,1))
+
+!       1.5 Interpolating data at the Gauss quadrature points:
+        DO gausind=1,ngau
+          drad=radiusr*radgaus(gausind)
+          radGAUSa(gausind,iaer,idomain)=radiusm-drad
+
+          radius_id=minloc(abs(radiustab(iaer,idomain,:) - (radiusm-drad)),DIM=1)
+          IF ((radiustab(iaer,idomain,radius_id) - (radiusm-drad)).GT.0) THEN
+            radius_id=radius_id-1
+          ENDIF
+          IF (radius_id.GE.nsize(iaer,idomain)) THEN
+            radius_id=nsize(iaer,idomain)-1
+            kint = 1.
+          ELSEIF (radius_id.LT.1) THEN
+            radius_id=1
+            kint = 0.
+          ELSE
+          kint = ( (radiusm-drad) -				&
+                   radiustab(iaer,idomain,radius_id) ) /	&
+                 ( radiustab(iaer,idomain,radius_id+1) -	&
+                   radiustab(iaer,idomain,radius_id) )
+          ENDIF
+          IF (idomain.EQ.1) THEN ! VISIBLE DOMAIN -----------------
+            DO m=1,L_NSPECTV
+               qsqrefVISa(m,gausind,iaer)=                      &
+                    (1-kint)*QVISsQREF(m,iaer,radius_id) +      &
+                    kint*QVISsQREF(m,iaer,radius_id+1)
+            omegVISa(m,gausind,iaer)=                           &
+                    (1-kint)*omegaVIS(m,iaer,radius_id) +       &
+                    kint*omegaVIS(m,iaer,radius_id+1)
+            gVISa(m,gausind,iaer)=                              &
+                    (1-kint)*gVIS(m,iaer,radius_id) +           &
+                    kint*gVIS(m,iaer,radius_id+1)
+            ENDDO
+            qrefVISa(gausind,iaer)=                             &
+                    (1-kint)*QREFvis(iaer,radius_id) +          &
+                    kint*QREFvis(iaer,radius_id+1)
+            omegrefVISa(gausind,iaer)=                          &
+                    (1-kint)*omegaREFvis(iaer,radius_id) +      &
+                    kint*omegaREFvis(iaer,radius_id+1)
+          ELSE ! INFRARED DOMAIN ----------------------------------
+            DO m=1,L_NSPECTI
+            qsqrefIRa(m,gausind,iaer)=                          &
+                    (1-kint)*QIRsQREF(m,iaer,radius_id) +       &
+                    kint*QIRsQREF(m,iaer,radius_id+1)
+            omegIRa(m,gausind,iaer)=                            &
+                    (1-kint)*omegaIR(m,iaer,radius_id) +        &
+                    kint*omegaIR(m,iaer,radius_id+1)
+            gIRa(m,gausind,iaer)=                               &
+                    (1-kint)*gIR(m,iaer,radius_id) +            &
+                    kint*gIR(m,iaer,radius_id+1)
+            ENDDO
+            qrefIRa(gausind,iaer)=                              &
+                    (1-kint)*QREFir(iaer,radius_id) +           &
+                    kint*QREFir(iaer,radius_id+1)
+            omegrefIRa(gausind,iaer)=                           &
+                    (1-kint)*omegaREFir(iaer,radius_id) +       &
+                    kint*omegaREFir(iaer,radius_id+1)
+          ENDIF
+        ENDDO
+
+        DO gausind=1,ngau
+          drad=radiusr*radgaus(gausind)
+          radGAUSb(gausind,iaer,idomain)=radiusm+drad
+
+          radius_id=minloc(abs(radiustab(iaer,idomain,:) -      &
+                               (radiusm+drad)),DIM=1)
+          IF ((radiustab(iaer,idomain,radius_id) -              &
+               (radiusm+drad)).GT.0) THEN
+            radius_id=radius_id-1
+          ENDIF
+          IF (radius_id.GE.nsize(iaer,idomain)) THEN
+            radius_id=nsize(iaer,idomain)-1
+            kint = 1.
+          ELSEIF (radius_id.LT.1) THEN
+            radius_id=1
+            kint = 0.
+          ELSE
+            kint = ( (radiusm+drad) -                           &
+                     radiustab(iaer,idomain,radius_id) ) /      &
+                   ( radiustab(iaer,idomain,radius_id+1) -      &
+                     radiustab(iaer,idomain,radius_id) )
+          ENDIF
+          IF (idomain.EQ.1) THEN ! VISIBLE DOMAIN -----------------
+            DO m=1,L_NSPECTV
+            qsqrefVISb(m,gausind,iaer)=                         &
+                    (1-kint)*QVISsQREF(m,iaer,radius_id) +      &
+                    kint*QVISsQREF(m,iaer,radius_id+1)    
+            omegVISb(m,gausind,iaer)=                           &
+                    (1-kint)*omegaVIS(m,iaer,radius_id) +       &
+                    kint*omegaVIS(m,iaer,radius_id+1)
+            gVISb(m,gausind,iaer)=                              &
+                    (1-kint)*gVIS(m,iaer,radius_id) +           &
+                    kint*gVIS(m,iaer,radius_id+1)
+            ENDDO
+            qrefVISb(gausind,iaer)=                             &
+                    (1-kint)*QREFvis(iaer,radius_id) +          &
+                    kint*QREFvis(iaer,radius_id+1)
+            omegrefVISb(gausind,iaer)=                          &
+                    (1-kint)*omegaREFvis(iaer,radius_id) +      &
+                    kint*omegaREFvis(iaer,radius_id+1)
+          ELSE ! INFRARED DOMAIN ----------------------------------
+            DO m=1,L_NSPECTI
+            qsqrefIRb(m,gausind,iaer)=                          &
+                    (1-kint)*QIRsQREF(m,iaer,radius_id) +       &
+                    kint*QIRsQREF(m,iaer,radius_id+1)
+            omegIRb(m,gausind,iaer)=                            &
+                    (1-kint)*omegaIR(m,iaer,radius_id) +        &
+                    kint*omegaIR(m,iaer,radius_id+1)
+            gIRb(m,gausind,iaer)=                               &
+                    (1-kint)*gIR(m,iaer,radius_id) +            &
+                    kint*gIR(m,iaer,radius_id+1)
+            ENDDO
+            qrefIRb(gausind,iaer)=                              &
+                    (1-kint)*QREFir(iaer,radius_id) +           &
+                    kint*QREFir(iaer,radius_id+1)
+            omegrefIRb(gausind,iaer)=                           &
+                    (1-kint)*omegaREFir(iaer,radius_id) +       &
+                    kint*omegaREFir(iaer,radius_id+1)
+          ENDIF
+        ENDDO
+
+!==================================================================
+! CONSTANT NUEFF FROM HERE
+!==================================================================
 
 !     2. Compute the scattering parameters using linear
 !       interpolation over grain sizes and constant nueff
 !     ---------------------------------------------------
-
-!     2.1 Initialization
-
-      vrat = log(radiustab(iaer,idomain,nsize(iaer,idomain)) / &
-              radiustab(iaer,idomain,1)) / &
-              float(nsize(iaer,idomain)-1)*3.
-      vrat = exp(vrat)
-
-      radiusint(1) = 1.e-9
-      DO i = 2,nsize(iaer,idomain)
-        radiusint(i) = ( (2.*vrat) / (vrat+1.) )**(1./3.) * &
-                      radiustab(iaer,idomain,i-1)
-      ENDDO
-      radiusint(nsize(iaer,idomain)+1) = 1.e-2
 
       DO lg = 1,nlayer
